﻿
using System.Collections.Generic;
using System.Text;
using com.upay.utils;
using com.upay.Entity;
using Newtonsoft.Json;

namespace com.upay.transferSingle
{
    public class transferSingleOrder : RequestObject
    {
      

        /// <summary>
        /// 商户编号
        /// </summary>
        [JsonProperty(PropertyName = "merchantId")]
        public string MerchantId { get; set; }

        /// <summary>
        /// 订单号
        /// </summary>
        [JsonProperty(PropertyName = "requestId")]
        public string RequestId { get; set; }

        /// <summary>
        /// 汇款金额币种
        /// </summary>
        [JsonProperty(PropertyName = "currency")]
        public string Currency { get; set; }


        /// <summary>
        /// 订单金额
        /// </summary>
        [JsonProperty(PropertyName = "amount")]
        public string Amount { get; set; }

        /// <summary>
        /// 通知地址   
        /// </summary>
        [JsonProperty(PropertyName = "notifyUrl")]
        public string notifyUrl { get; set; }

        /// <summary>
        /// 备注   
        /// </summary>
        [JsonProperty(PropertyName = "remark")]
        public string remark { get; set; }

        /// <summary>
        /// 收款人信息
        /// </summary>
        [JsonProperty(PropertyName = "payee")]
        public TransferDomesticPayee payee { get; set; }

        /// <summary>
        /// 签名   
        /// </summary>

        [JsonProperty(PropertyName = "hmac")]
        public string hmac { get; set; }

        }


    }

